%define real_name bash

%define _libdir64 %{_prefix}/lib64

Name: bash_64
Summary: The GNU Bourne Again shell (bash) version %{version} (64-bit)
Version: 4.4
Release: 5
Group: System Environment/Shells
License: GPLv2+
Url: http://www.gnu.org/software/bash
Source0: ftp://ftp.gnu.org/gnu/bash/%{real_name}-%{version}.tar.gz
Source1: ftp://ftp.gnu.org/gnu/bash/%{real_name}-%{version}.tar.gz.sig
# Official upstream patches
Patch1: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-001
Patch2: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-002
Patch3: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-003
Patch4: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-004
Patch5: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-005
Patch6: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-006
Patch7: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-007
Patch8: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-008
Patch9: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-009
Patch10: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-010
Patch11: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-011
Patch12: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-012
Patch13: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-013
Patch14: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-014
Patch15: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-015
Patch16: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-016
Patch17: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-017
Patch18: ftp://ftp.gnu.org/gnu/bash/bash-4.4-patches/bash44-018

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: bison, patch

Provides: bash

%description
The GNU Bourne Again shell (Bash) is a shell or command language
interpreter that is compatible with the Bourne shell (sh). Bash
incorporates useful features from the Korn shell (ksh) and the C shell
(csh). Most sh scripts can be run by bash without modification. This
package (bash) contains bash version %{version}, which improves POSIX
compliance over previous versions.


%prep
%setup -q -n %{real_name}-%{version}
export PATH=/opt/freeware/bin:$PATH
# Official upstream patches
%patch1 -p0 -b .001
%patch2 -p0 -b .002
%patch3 -p0 -b .003
%patch4 -p0 -b .004
%patch5 -p0 -b .005
%patch6 -p0 -b .006
%patch7 -p0 -b .007
%patch8 -p0 -b .008
%patch9 -p0 -b .009
%patch10 -p0 -b .010
%patch11 -p0 -b .011
%patch12 -p0 -b .012
%patch13 -p0 -b .013
%patch14 -p0 -b .014
%patch15 -p0 -b .015
%patch16 -p0 -b .016
%patch17 -p0 -b .017
%patch18 -p0 -b .018


%build
export OBJECT_MODE=64

export CC="xlc_r"

# avoid inclusion of local directories into the binaries
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

./configure \
    --prefix=%{_prefix} \
    --infodir=%{_infodir} \
    --mandir=%{_mandir} \
    --with-included-gettext


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

export OBJECT_MODE=64

make DESTDIR=${RPM_BUILD_ROOT} install

cp doc/builtins.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/
chmod 0644 ${RPM_BUILD_ROOT}%{_mandir}/man1/*

/usr/bin/strip -X64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*info*
rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir

mkdir -p ${RPM_BUILD_ROOT}/bin
mkdir -p ${RPM_BUILD_ROOT}/usr/bin
ln -sf ../..%{_bindir}/bash ${RPM_BUILD_ROOT}/bin/bash
ln -sf ../..%{_bindir}/bash ${RPM_BUILD_ROOT}/usr/bin/bash
ln -sf ../..%{_prefix}/bin/bashbug ${RPM_BUILD_ROOT}/usr/bin/bashbug

{
  cd ${RPM_BUILD_ROOT}
  cd bin
  ln -sf bash bash2
  cd ../usr/bin
  ln -sf bashbug bash2bug
}


%post
if [ ! -f /etc/shells ]; then
    echo "%{_bindir}/bash" >> /etc/shells
else
    grep -q '^%{_bindir}/bash$' /etc/shells || \
        echo "%{_bindir}/bash" >> /etc/shells
fi


%postun
if [ ! -x %{_bindir}/bash ]; then
    grep -v '^%{_bindir}/bash$' /etc/shells > /etc/shells.rpm && \
        mv /etc/shells.rpm /etc/shells
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc CHANGES COMPAT NEWS NOTES POSIX
%doc doc/FAQ doc/INTRO doc/article.ms doc/article.txt
%doc examples/functions/ examples/misc/
%doc examples/scripts/ examples/startup-files/ examples/complete/
%{_bindir}/*
%{_infodir}/bash.info*
%{_mandir}/man1/*
%{_datadir}/locale/*/*/*
/bin/bash*
/usr/bin/bash*


%changelog
* Tue Jan 30 2018 Michael Perzl <michael@perzl.org> - 4.4-5
- updated to version 4.4 patch level 18

* Sun Feb 12 2017 Michael Perzl <michael@perzl.org> - 4.4-4
- updated to version 4.4 patch level 12

* Mon Jan 23 2017 Michael Perzl <michael@perzl.org> - 4.4-3
- updated to version 4.4 patch level 11

* Tue Nov 15 2016 Michael Perzl <michael@perzl.org> - 4.4-2
- updated to version 4.4 patch level 05

* Fri Sep 16 2016 Michael Perzl <michael@perzl.org> - 4.4-1
- updated to version 4.4 patch level 00

* Fri Jul 01 2016 Michael Perzl <michael@perzl.org> - 4.3-19
- updated to version 4.3 patch level 46

* Sun Aug 16 2015 Michael Perzl <michael@perzl.org> - 4.3-18
- updated to version 4.3 patch level 42

* Tue Jul 07 2015 Michael Perzl <michael@perzl.org> - 4.3-17
- updated to version 4.3 patch level 39

* Wed May 27 2015 Michael Perzl <michael@perzl.org> - 4.3-16
- updated to version 4.3 patch level 38

* Tue Mar 03 2015 Michael Perzl <michael@perzl.org> - 4.3-15
- avoid inclusion of local directories into the binaries

* Tue Jan 20 2015 Michael Perzl <michael@perzl.org> - 4.3-14
- updated to version 4.3 patch level 33

* Sat Oct 11 2014 Michael Perzl <michael@perzl.org> - 4.3-13
- added missing "provides bash"

* Sun Oct 05 2014 Michael Perzl <michael@perzl.org> - 4.3-12
- updated to version 4.3 patch level 30

* Fri Oct 03 2014 Michael Perzl <michael@perzl.org> - 4.3-11
- updated to version 4.3 patch level 29

* Wed Oct 01 2014 Michael Perzl <michael@perzl.org> - 4.3-10
- updated to version 4.3 patch level 28

* Mon Sep 29 2014 Michael Perzl <michael@perzl.org> - 4.3-9
- updated to version 4.3 patch level 27

* Fri Sep 26 2014 Michael Perzl <michael@perzl.org> - 4.3-8
- fixes CVE-2014-7169 by using the published Fedora Linux patches

* Wed Sep 24 2014 Michael Perzl <michael@perzl.org> - 4.3-7
- updated to version 4.3 patch level 25
- fixes CVE-2014-6271

* Thu Aug 21 2014 Michael Perzl <michael@perzl.org> - 4.3-6
- updated to version 4.3 patch level 24

* Fri Aug 15 2014 Michael Perzl <michael@perzl.org> - 4.3-5
- updated to version 4.3 patch level 22

* Mon May 19 2014 Michael Perzl <michael@perzl.org> - 4.3-4
- updated to version 4.3 patch level 18

* Sun Apr 27 2014 Michael Perzl <michael@perzl.org> - 4.3-3
- updated to version 4.3 patch level 11

* Fri Mar 27 2014 Michael Perzl <michael@perzl.org> - 4.3-2
- updated to version 4.3 patch level 8

* Wed Feb 26 2014 Michael Perzl <michael@perzl.org> - 4.3-1
- updated to version 4.3

* Thu Mar 07 2013 Michael Perzl <michael@perzl.org> - 4.2-12
- updated to version 4.2 patch level 45

* Thu Jan 03 2013 Michael Perzl <michael@perzl.org> - 4.2-11
- updated to version 4.2 patch level 42

* Sun Nov 04 2012 Michael Perzl <michael@perzl.org> - 4.2-10
- updated to version 4.2 patch level 39

* Wed Jul 18 2012 Michael Perzl <michael@perzl.org> - 4.2-9
- updated to version 4.2 patch level 37

* Tue Jul 10 2012 Michael Perzl <michael@perzl.org> - 4.2-8
- updated to version 4.2 patch level 36

* Wed Jun 13 2012 Michael Perzl <michael@perzl.org> - 4.2-7
- updated to version 4.2 patch level 29

* Mon Apr 16 2012 Michael Perzl <michael@perzl.org> - 4.2-6
- updated to version 4.2 patch level 24

* Mon May 16 2011 Michael Perzl <michael@perzl.org> - 4.2-5
- updated to version 4.2 patch level 10

* Sun Mar 20 2011 Michael Perzl <michael@perzl.org> - 4.2-4
- updated to version 4.2 patch level 8

* Tue Mar 01 2011 Michael Perzl <michael@perzl.org> - 4.2-3
- updated to version 4.2 patch level 5

* Tue Feb 24 2011 Michael Perzl <michael@perzl.org> - 4.2-2
- rebuilt without dependency on libiconv

* Tue Feb 15 2011 Michael Perzl <michael@perzl.org> - 4.2-1
- updated to version 4.2

* Mon Jan 10 2011 Michael Perzl <michael@perzl.org> - 4.1-6
- automatically add entry to /etc/shells

* Wed Oct 13 2010 Michael Perzl <michael@perzl.org> - 4.1-5
- updated to version 4.1 patch level 9

* Thu May 20 2010 Michael Perzl <michael@perzl.org> - 4.1-4
- updated to version 4.1 patch level 7

* Wed Apr 07 2010 Michael Perzl <michael@perzl.org> - 4.1-3
- updated to version 4.1 patch level 5

* Tue Jan 19 2010 Michael Perzl <michael@perzl.org> - 4.1-2
- updated to version 4.1 patch level 2

* Fri Jan 08 2010 Michael Perzl <michael@perzl.org> - 4.1-1
- updated to version 4.1

* Thu Nov 26 2009 Michael Perzl <michael@perzl.org> - 4.0-3
- updated to version 4.0 patch level 35

* Tue Jul 07 2009 Michael Perzl <michael@perzl.org> - 4.0-2
- updated to version 4.0 patch level 24

* Mon Mar 30 2009 Michael Perzl <michael@perzl.org> - 4.0-1
- updated to version 4.0 and patch level 10

* Mon Mar 30 2009 Michael Perzl <michael@perzl.org> - 3.2-2
- updated to latest patch level 3.2.48

* Tue Mar 18 2008 Michael Perzl <michael@perzl.org> - 3.2-1
- first version for AIX V5.1 and higher
